#!/usr/bin/env python3
import sys
import os
from PyQt5 import QtCore, QtWidgets, QtGui
from PyQt5.QtWidgets import QMainWindow, QWidget, QLabel, QLineEdit
from PyQt5.QtWidgets import QPushButton
from PyQt5.QtCore import QSize, QLocale, QProcess
from PyQt5.QtGui import QIcon

class MainWindow(QMainWindow):
    def __init__(self, filename, TestQFileDialog):
        QMainWindow.__init__(self)
        self.file = filename
        self.locale = os.environ.get('LANG', None)
        self.setMinimumSize(QSize(360, 220))    
        self.setWindowTitle(self._("UpdateDesktopEntry"))
        TestQFileDialog.setObjectName("TestQFileDialog")
        self.dialog = TestQFileDialog

        self.nameLabel = QLabel(self)
        self.nameLabel.setText(self._('Name:'))
        self.nameline = QLineEdit(self)

        #self.commentLabel = QLabel(self)
        #self.commentLabel.setText(self._('Exec:'))
        #self.execline = QLineEdit(self)
        #self.execline.setEnabled (False)

        self.descriptionLabel = QLabel(self)
        self.descriptionLabel.setText(self._('Icon:'))
        self.iconline = QLineEdit(self)
        self.iconline.setEnabled (False)

        self.nameline.move(100, 40)  #20
        self.nameline.resize(200, 32)
        self.nameLabel.move(20, 40) #20

        #self.execline.move(100, 60)
        #self.execline.resize(200, 32)
        #self.commentLabel.move(20, 60)

        self.iconline.move(100, 100)
        self.iconline.resize(200, 32)
        self.descriptionLabel.move(20, 100)

        # 打开执行文件按钮
        #self.execbtn = QPushButton(self)
        #self.execbtn.setObjectName ('exec')
        #self.execbtn.setIcon(QIcon.fromTheme("folder-open.png"))
        #self.execbtn.resize (32, 32)
        #self.execbtn.move(310, 60)
        #self.execbtn.clicked.connect(lambda: self._open_file_dialog('exec'))

        # 打开图标文件按钮
        self.iconbtn = QPushButton(self)
        self.iconbtn.setObjectName ('icon')
        self.iconbtn.setIcon(QIcon.fromTheme("folder-open.png"))
        self.iconbtn.resize (32, 32)
        self.iconbtn.move(310, 100)
        self.iconbtn.clicked.connect(lambda: self._open_file_dialog('icon'))

        self.pybutton = QPushButton(self._('OK'), self)
        self.pybutton.clicked.connect(self.clickMethod)
        self.pybutton.resize(66,32)
        self.pybutton.move(160, 160)
        self._white()

    def _white (self):
        myPalette = QtGui.QPalette()
        myPalette.setColor (QtGui.QPalette.Window, QtGui.QColor (250, 250, 255))
        self.setPalette (myPalette)
        
        buttonPalette = self.pybutton.palette()
        buttonPalette.setColor (self.pybutton.backgroundRole(), QtGui.QColor (250, 250, 255))

    def _open_file_dialog(self, typename):
        directotr = None
        filtername = None

        if typename == 'exec':
            directory, filtername = self.dialog.getOpenFileName(None, None, '/usr/bin')
            self.execline.setText('{}'.format(directory))
        elif typename == 'icon':
            directory, filtername = self.dialog.getOpenFileName(None, None, '/usr/share/icons', "(*.png)")
            self.iconline.setText('{}'.format(directory))

    def clickMethod(self):
        name_str = ''
        exec_str = '' 
        description_str = ''
        name = self.nameline.text()
        if name != '':
            name_str = " --set-name=" + name

        #execbin = self.execline.text()
        #if execbin != '':
        #    exec_str = " --set-exec=" + execbin

        description = self.iconline.text()
        if description != '':
            description_str = " --set-icon=" + description

        #executable = os.access (self.file, os.X_OK)
        # 将 pkexec 封装到脚本，报错:Refusing to render service to dead parents.
        command = "/usr/bin/desktop-entry-edit.sh " + name_str + description_str +\
                        " " + self.file
        print (command)
        p = QProcess()
        p.startDetached (command)
        self.close()



    def _(self, text):
        if self.locale == 'zh_CN.UTF-8':
            if text == 'Name:':
                return "名称："
            if text == 'Icon:':
                return "图标:"
            if text == 'Exec:':
                return '执行程序：'
            if text == 'UpdateDesktopEntry':
                return '编辑启动配置文件'
            if text == 'OK':
                return "确认"
        else:
            return text;

if __name__ == "__main__":
    app = QtWidgets.QApplication(sys.argv)
    app.setWindowIcon(QIcon('/usr/share/icons/desktop-edit.png'))
    #self.setWindowIcon(QIcon("system-run.png"))
    # 打开文件夹
    TestQFileDialog = QtWidgets.QFileDialog()

    mainWin = MainWindow(sys.argv[1], TestQFileDialog)
    mainWin.show()
    sys.exit( app.exec_() )
